""""Different ways of handling exception, for the moment none works"""


def divide_and_force(analyzed_job, binary_tree):
    # Move the father to suspend queue
    # print("Exception found!", analyzed_job.kind_of_exception())
    binary_tree.move_to_suspended(analyzed_job)

    child_1, child_2 = analyzed_job.child
    hash_1, hash_2 = child_1.hash, child_2.hash
    # The analysis variables of one child are the forced variables of the other one
    child_1.forced_ids.extend(child_2.id_reduced_precision)
    child_2.forced_ids.extend(child_1.id_reduced_precision)

    # Avoid loops making them fail
    if child_1.hash == hash_1 or child_2.hash == hash_2:
        binary_tree.move_to_failed(analyzed_job)
    else:
        for ch in analyzed_job.child:
            if ch in binary_tree.all():
                binary_tree[ch.status].remove(ch)
            binary_tree.pending.append(ch)
            ch.status = "PENDING"
            # Disinherit all child's descendants
            for job in ch.descendants():
                job.parent = None
            ch.child = []
    # Save disinherited jobs
    disinherited = [j for j in binary_tree.all() if j.parent is None and j.level != 0]
    for job in disinherited:
        binary_tree[job.status].remove(job)
        if job not in binary_tree.disinherited:
            binary_tree.disinherited.append(job)


def choose_child(analyzed_job, binary_tree):
    if len(analyzed_job.child[0].id_reduced_precision) == len(analyzed_job.child[1].id_reduced_precision) == 1:
        # the variables are good separately but bad together
        analyzed_job.banned_variables += analyzed_job.child[0].id_reduced_precision + analyzed_job.child[1].id_reduced_precision \
                                         + analyzed_job.child[0].banned_variables + analyzed_job.child[
                                             1].banned_variables
        analyzed_job.banned_variables = set(analyzed_job.banned_variables)
        binary_tree.move_to_failed(analyzed_job)
    else:
        # Exception handling
        analyzed_job.print_info_job("suspended")
        print("Job failed while kids were ok, reanalyzing")
        # One of the child that failed together, has never been divided: divide, and try to find the bad var
        if not analyzed_job.child[0].child or not analyzed_job.child[1].child:
            # Try to find the bad variables anyway
            if len((set([analyzed_job.vault.get_variable_by_id(v_id).module.name for v_id in
                      analyzed_job.id_reduced_precision]))) > 1:

                divide_and_force(analyzed_job, binary_tree)
            else:
                analyzed_job.banned_variables += analyzed_job.child[0].id_reduced_precision + analyzed_job.child[
                    1].id_reduced_precision \
                                                 + analyzed_job.child[0].banned_variables + analyzed_job.child[
                                                     1].banned_variables
                binary_tree.move_to_failed(analyzed_job)
            return

        # Choose one of the child
        if len(analyzed_job.child[0].banned_variables) == len(analyzed_job.child[1].banned_variables):
            # No banned variables, then ban the smalled analysis set, or promote child 0 if the len is the same
            if len(analyzed_job.child[0].id_reduced_precision) >= len(analyzed_job.child[0].id_reduced_precision):
                success_child = analyzed_job.child[0]
                failed_child = analyzed_job.child[1]
            else:
                success_child = analyzed_job.child[1]
                failed_child = analyzed_job.child[2]
        elif len(analyzed_job.child[0].banned_variables) > len(analyzed_job.child[1].banned_variables):
            # Ban the child with the greatest number of banned variables
            success_child = analyzed_job.child[1]
            failed_child = analyzed_job.child[0]
        else:
            success_child = analyzed_job.child[0]
            failed_child = analyzed_job.child[1]
        # Too much variables banned at once, try to combine the child once
        if len(failed_child.id_reduced_precision) > 10 and not analyzed_job.reshuffle:
            # Mark the job, so not to rerun this an infinite number of times
            # shuffle_child_two_group(analyzed_job, binary_tree)
            run_node_5(analyzed_job)
            binary_tree.move_to_suspended(analyzed_job)
            for ch in analyzed_job.child:
                if ch not in binary_tree.all():
                    binary_tree.move_to_pending(ch)
            return
        binary_tree.move_to_failed(failed_child)

        analyzed_job.id_reduced_precision = success_child.id_reduced_precision
        analyzed_job.banned_variables = failed_child.id_reduced_precision + failed_child.banned_variables + \
                                        success_child.banned_variables
        binary_tree.move_to_success(analyzed_job)


def shuffle_child_two_group(analyzed_job, binary_tree):
    child_1, child_2 = analyzed_job.child

    nephew_1_id_reduced_precision = child_1.child[0].id_reduced_precision[:]
    nephew_2_id_reduced_precision = child_1.child[1].id_reduced_precision[:]
    nephew_3_id_reduced_precision = child_2.child[0].id_reduced_precision[:]
    nephew_4_id_reduced_precision = child_2.child[1].id_reduced_precision[:]

    banned_variables = child_1.child[0].banned_variables[:] + child_1.child[1].banned_variables[:] + \
                       child_2.child[0].banned_variables[:] + child_2.child[1].banned_variables[:]

    # Delete old child
    analyzed_job.child = []
    analyzed_job.banned_variables = []

    # Create new ones
    analyzed_job.spawn_children([nephew_1_id_reduced_precision + nephew_3_id_reduced_precision])
    analyzed_job.spawn_children([nephew_1_id_reduced_precision + nephew_4_id_reduced_precision])
    analyzed_job.spawn_children([nephew_2_id_reduced_precision + nephew_3_id_reduced_precision])
    analyzed_job.spawn_children([nephew_2_id_reduced_precision + nephew_4_id_reduced_precision])

    analyzed_job.child[0].reshuffle = True
    analyzed_job.child[1].reshuffle = True
    analyzed_job.child[2].reshuffle = True
    analyzed_job.child[3].reshuffle = True

    analyzed_job.child[0].banned_variables = banned_variables + \
                                             nephew_2_id_reduced_precision + nephew_4_id_reduced_precision
    analyzed_job.child[1].banned_variables = banned_variables + \
                                             nephew_2_id_reduced_precision + nephew_3_id_reduced_precision
    analyzed_job.child[2].banned_variables = banned_variables + \
                                             nephew_1_id_reduced_precision + nephew_4_id_reduced_precision
    analyzed_job.child[3].banned_variables = banned_variables + \
                                             nephew_1_id_reduced_precision + nephew_3_id_reduced_precision

    binary_tree.move_to_pending(analyzed_job.child[0])
    binary_tree.move_to_pending(analyzed_job.child[1])
    binary_tree.move_to_pending(analyzed_job.child[2])
    binary_tree.move_to_pending(analyzed_job.child[3])

    return


def shuffle_child_three_group(analyzed_job, binary_tree):
    child_1, child_2 = analyzed_job.child

    nephew_1_id_reduced_precision = child_1.child[0].id_reduced_precision[:]
    nephew_2_id_reduced_precision = child_1.child[1].id_reduced_precision[:]
    nephew_3_id_reduced_precision = child_2.child[0].id_reduced_precision[:]
    nephew_4_id_reduced_precision = child_2.child[1].id_reduced_precision[:]

    banned_variables = child_1.child[0].banned_variables[:] + child_1.child[1].banned_variables[:] + \
                       child_2.child[0].banned_variables[:] + child_2.child[1].banned_variables[:]

    # Delete old child
    analyzed_job.child = []
    analyzed_job.banned_variables = []

    # Create new ones
    analyzed_job.spawn_children([nephew_1_id_reduced_precision + nephew_2_id_reduced_precision + nephew_3_id_reduced_precision])
    analyzed_job.spawn_children([nephew_1_id_reduced_precision + nephew_2_id_reduced_precision + nephew_4_id_reduced_precision])
    analyzed_job.spawn_children([nephew_1_id_reduced_precision + nephew_3_id_reduced_precision + nephew_4_id_reduced_precision])
    analyzed_job.spawn_children([nephew_2_id_reduced_precision + nephew_3_id_reduced_precision + nephew_4_id_reduced_precision])

    analyzed_job.child[0].reshuffle = True
    analyzed_job.child[1].reshuffle = True
    analyzed_job.child[2].reshuffle = True
    analyzed_job.child[3].reshuffle = True

    analyzed_job.child[0].banned_variables = banned_variables + nephew_4_id_reduced_precision
    analyzed_job.child[1].banned_variables = banned_variables + nephew_3_id_reduced_precision
    analyzed_job.child[2].banned_variables = banned_variables + nephew_2_id_reduced_precision
    analyzed_job.child[3].banned_variables = banned_variables + nephew_1_id_reduced_precision

    binary_tree.move_to_pending(analyzed_job.child[0])
    binary_tree.move_to_pending(analyzed_job.child[1])
    binary_tree.move_to_pending(analyzed_job.child[2])
    binary_tree.move_to_pending(analyzed_job.child[3])

    return


def _find_child_set(job, analysis_set_dict):
    if job.status == 'FAILED' or not job.child:
        return
    else:
        try:
            analysis_set_dict[job.hash]
        except KeyError:
            analysis_set_dict[job.hash] = job.id_reduced_precision
            for child in job.child:
                _find_child_set(child, analysis_set_dict)


def run_node_5(analyzed_job):
    child_analysis_set_dict = {}
    _find_child_set(analyzed_job, child_analysis_set_dict)
    # child_analysis_set_list.sort(key=lambda x: len(x))
    all_id = []
    all_banned_var = []
    for child_hash in child_analysis_set_dict:
        i_id_red_precision = analyzed_job.id_reduced_precision[:]
        i_banned_var = analyzed_job.banned_variables[:]
        for v_id in child_analysis_set_dict[child_hash]:
            if v_id not in i_banned_var:
                i_id_red_precision.remove(v_id)
                i_banned_var.append(v_id)
        all_id.append(i_id_red_precision)
        all_banned_var.append(i_banned_var)
    # Save old child structure, that will be destroyed in creating new ones
    analyzed_job.reshuffle = analyzed_job.child[:]
    analyzed_job.run_children(_id_subset=all_id,
                              _banned_variables=all_banned_var,
                              children_index=[*child_analysis_set_dict.keys()])


# Do not perform other action, the set is considered as FAILED
def divide_or_fail(analyzed_job, queue):
    analyzed_job.move_to_failed(queue)
